config/routes.rb
Rails.application.routes.draw do
  devise_for :users

  resources :tasks

  root 'home#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/task.rb
require 'classes/siblings_extractor'

class Task < ApplicationRecord
  validates :title, presence: true
  validates :description, presence: true
  validates :user_id, presence: true

  belongs_to :user
  # Ancestors are TasksOrders with child equal to current task
  has_many :ancestors_order, class_name: 'TaskOrder', foreign_key: :child_id, inverse_of: :child, dependent: :destroy
  # Children are TasksOrders with ancestor equal to current task
  has_many :children_order, class_name: 'TaskOrder', foreign_key: :ancestor_id, inverse_of: :ancestor, dependent: :destroy
  has_many :ancestors, class_name: 'Task', through: :ancestors_order
  has_many :children, class_name: 'Task', through: :children_order

  before_validation :extract_siblings
  after_create :link_siblings

  def add_child(task)
    children.push task_or_id(task)
  end

  def add_ancestor(task)
    ancestors.push task_or_id(task)
  end

  def full_graph
    extractor = SiblingsExtractor.new self

    {
      siblings: extractor.siblings,
      orders:   extractor.orders,
    }
  end

  private

  def task_or_id(element)
    if element.is_a? Integer
      Task.find element
    elsif element.is_a? Task
      element
    else
      raise "This is not a task nor an ID (#{element.class})"
    end
  end

  # Used before validation to remove siblings because current task has no ID before
  # creation. @siblings is then used to create ancestors and children to the task
  def extract_siblings
    return if id

    @siblings         = { ancestors: ancestor_ids, children: child_ids }
    self.ancestor_ids = []
    self.child_ids    = []
  end

  def link_siblings
    @siblings[:ancestors].each { |id| add_ancestor id }
    @siblings[:children].each { |id| add_child id }
  end
end

app/models/task_order.rb
class TaskOrder < ApplicationRecord
  belongs_to :ancestor, class_name: 'Task', inverse_of: :ancestors
  belongs_to :child, class_name: 'Task', inverse_of: :children
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  validates :username, uniqueness: true

  has_many :tasks, dependent: :nullify
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :configure_permitted_parameters, if: :devise_controller?

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name, :username])
    devise_parameter_sanitizer.permit(:account_update, keys: [:name])
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index; end
end

app/controllers/tasks_controller.rb
class TasksController < UserApplicationController
  before_action :set_task, only: [:show, :edit, :update, :destroy]

  # GET /tasks
  # GET /tasks.json
  def index
    @tasks = Task.all
  end

  # GET /tasks/1
  # GET /tasks/1.json
  def show; end

  # GET /tasks/new
  def new
    @task              = Task.new
    @task.ancestor_ids = [params[:ancestor_id]] if params[:ancestor_id]
    @task.child_ids    = [params[:child_id]] if params[:child_id]
  end

  # GET /tasks/1/edit
  def edit; end

  # POST /tasks
  # POST /tasks.json
  def create
    @task = Task.new(task_params)
    @task.user = current_user

    respond_to do |format|
      if @task.save
        format.html { redirect_to @task, notice: t('.success') }
        format.json { render :show, status: :created, location: @task }
      else
        format.html { render :new }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tasks/1
  # PATCH/PUT /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to @task, notice: t('.success') }
        format.json { render :show, status: :ok, location: @task }
      else
        format.html { render :edit }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tasks/1
  # DELETE /tasks/1.json
  def destroy
    @task.destroy
    respond_to do |format|
      format.html { redirect_to tasks_url, notice: t('.success') }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_task
    @task = Task.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def task_params
    params.require(:task).permit(:title, :description, :user_id, ancestor_ids: [], child_ids: [])
  end
end

app/controllers/user_application_controller.rb
class UserApplicationController < ApplicationController
  before_action :authenticate_user!
end

app/helpers/application_helper.rb
module ApplicationHelper
  def authored?(entity, user: nil, user_id: nil)
    id = user_id || user || current_user&.id
    entity.user_id == id
  end
end

app/views/home/index.en.html.haml
%p
  The goal of this application is to create a community list of connected tasks,
  and help people find help to organize themselves.

%p
  This is in early alpha, feel free to create an account, things should evolve
  quickly.

app/views/layouts/_flash_messages.html.haml
- unless flash.empty?
  .flash-messages
    - flash.each do |name, message|
      %div{ class: "alert alert--#{name}" }= message

app/views/layouts/application.html.haml
!!!
%html
  %head
    %meta{ :content => 'text/html; charset=UTF-8', 'http-equiv' => 'Content-Type' }/
    %meta{ name: 'viewport',
           content: 'width=device-width, user-scalable=no, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0' }
    %meta{ 'http-equiv': 'X-UA-Compatible', content: 'ie=edge' }
    %title Dhelp
    = csrf_meta_tags
    = csp_meta_tag
    = stylesheet_link_tag 'application', media: 'all'
    = stylesheet_link_tag 'theme_light'
    = javascript_pack_tag 'application'
  %body
    %nav.main-menu
      .main-menu__main
        = link_to t('.home'), root_path
      .main-menu__links.main-menu__links
        - unless current_user
          = link_to t('.login_logout'), new_user_session_path
      - if current_user
        .main-menu__links.main-menu__links--expandable
          %button.main-menu__trigger #{t('.menu')} ▼
          .main-menu__links__content
            = link_to t('.tasks'), tasks_path
            = link_to t('devise.sessions.sign_out'), :destroy_user_session, method: :delete
        .main-menu__links.main-menu__links
          %button.main-menu__trigger #{t('.you')} ▼
          .main-menu__links__content
            = link_to t('.my_account'), edit_user_registration_path
    = render 'layouts/flash_messages'

    .page__content
      = yield

app/views/tasks/_form.html.haml
= form_for task do |f|
  - if task.errors.any?
    .form__error-explanation
      %h2= t('.save_error', amount: pluralize(task.errors.count, 'error'))
      %ul
        - task.errors.full_messages.each do |message|
          %li= message

  .form__field
    = f.label :title
    .form__input
      = f.text_field :title, required: true
  .form__field
    = f.label :description
    .form__input
      = f.text_area :description, required: true
  .form__field
    = f.label :ancestors
    .form__input
      = f.select(:ancestor_ids, Task.pluck(:title, :id), {}, multiple: true)
  .form__field
    = f.label :children
    .form__input
      = f.select(:child_ids, Task.pluck(:title, :id), {}, multiple: true)


  .form__actions
    = f.submit 'Save', class: 'add'

app/views/tasks/edit.html.haml
%h1= t('.title')

= render 'form', task: @task

= link_to t('generic.show'), @task
= link_to t('generic.back'), tasks_path

app/views/tasks/index.html.haml
%h1= t('.title')

.page__actions
  = link_to t('.new'), new_task_path, class: 'button'

- @tasks.each do |task|
  .card
    .card__title
      = link_to task.title, task
    - if authored?(task)
      .card__infos
        = button_to t('generic.edit'), edit_task_path(task), class: 'button'
        = button_to t('generic.destroy'),
                    task,
                    method: :delete,
                    data: { confirm: t('generic.confirm') },
                    class: 'destructive'
    .card__content= task.description

app/views/tasks/new.html.haml
%h1= t('.title')

.page__actions
  = link_to t('generic.back'), tasks_path

= render 'form', task: @task

app/views/tasks/show.html.haml
%h1= @task.title

.page__actions
  = link_to t('generic.back'), tasks_path, class: 'button'
  - if authored? @task
    = link_to t('generic.edit'), edit_task_path(@task), class: 'button'

%noscript
  .alert.alert--alert= t('.js_required')

- graph_data = @task.full_graph
- if graph_data[:siblings]
  %pre.mermaid#mermaid-source
    :preserve
      graph LR

    - graph_data[:siblings].each do |sibling|
      :preserve
        T#{sibling.id}#{sibling.id == @task.id ? "(#{sibling.title})" : "[#{sibling.title}]"}
        click T#{sibling.id} "#{url_for sibling}"

    - graph_data[:orders].each do |order|
      :preserve
        T#{order.ancestor_id} --> T#{order.child_id}

    :preserve

      plus_ancestor((+))
      plus_child((+))

      click plus_ancestor "#{new_task_url params: { child_id: @task.id }}"
      click plus_child "#{new_task_url params: { ancestor_id: @task.id }}"

      plus_ancestor -.-> T#{@task.id}
      T#{@task.id} -.-> plus_child

      class T#{@task.id} current
      class plus_ancestor add-node
      class plus_child add-node

  .mermaid__graph#mermaid-target

%p
  %b Title:
  = @task.title
%p
  %b User:
  = @task.user.username
%p
  %b Description:
  = @task.description

= javascript_pack_tag :mermaid
:javascript
  renderMermaidGraph('mermaid-source', 'mermaid-target')